## bnfc 2.1.2

=== Makefile ===
GHC = ghc
GHC_OPTS = -Wall
GHC_OPTS += -iformats -iformats/haskell -iformats/java -iformats/cpp -iformats/c  -iformats/oz
#GHC_OPTS += -package util

GHCI = ghci

HUGS = hugs

BNFC = bnfc
BNFC_OPTS = -alex2

all:
	$(GHC) $(GHC_OPTS) -iformats -iformats/haskell -iformats/java -iformats/cpp -iformats/c --make CFTop -o bnfc
ghci:
	$(GHCI) $(GHC_OPTS) -iformats -iformats/haskell -iformats/java -iformats/cpp -iformats/c CFTop
hugs:
	$(HUGS) -P.:for-hugs:formats:formats/haskell:formats/java:formats/cpp:formats/c:: CFTop

frontend:
	$(BNFC) $(BNFC_OPTS) -m BNF.cf ; $(MAKE) -f makefile ; rm makefile

clean: 
	rm -f *.hi *.o *.y *.aux *.log *~ formats/haskell/*.hi formats/haskell/*.o formats/haskell/*~ formats/*.hi formats/*.o formats/*~ formats/java/*.hi formats/java/*.o formats/java/*~ formats/cpp/*.hi formats/cpp/*.o formats/cpp/*~ formats/c/*.hi formats/c/*.o formats/c/*~

## bnfc 2.2

=== Makefile ===
VERSION=2.2
GHC = ghc
GHC_OPTS = #-Wall
GHC_OPTS += -iformats -iformats/haskell2 -iformats/xml -iformats/profile -iformats/java -iformats/java1.5 -iformats/cpp -iformats/c  -iformats/oz
#GHC_OPTS += -package util

GHCI = ghci

HUGS = hugs

BNFC = bnfc
BNFC_OPTS = -alex2

all:
	$(GHC) $(GHC_OPTS) --make CFTop -o bnfc
ghci:
	$(GHCI) $(GHC_OPTS) CFTop
hugs:
	$(HUGS) -P.:for-hugs:formats:formats/haskell2:formats/java:formats/java1.5:formats/cpp:formats/c:: CFTop

frontend:
	$(BNFC) $(BNFC_OPTS) -m BNF.cf ; $(MAKE) -f makefile ; rm makefile

distr:
	rm -fr BNFC_$(VERSION)
	mkdir BNFC_$(VERSION)
	cvs export -d BNFC_$(VERSION) -rHEAD BNFC
	rm -rf BNFC_$(VERSION)/doc/* ; cp doc/LBNF-report.tex BNFC_$(VERSION)/doc/
	tar cvfz BNFC_$(VERSION).tgz BNFC_$(VERSION)

clean: 
	rm -f *.hi *.o *.y *.aux *.log *~ formats/haskell2/*.hi formats/haskell2/*.o formats/haskell2/*~ formats/*.hi formats/*.o formats/*~ formats/java/*.hi formats/java/*.o formats/java/*~ formats/java1.5/*.hi formats/java1.5/*.o formats/java1.5/*~ formats/cpp/*.hi formats/cpp/*.o formats/cpp/*~ formats/c/*.hi formats/c/*.o formats/c/*~

## bnfc 2.4.2.0

=== debian/changelog ===
bnfc (2.4.2.0-2) unstable; urgency=low

  * debian/rules: Compile Setup.lhs at configure time, as some architectures
    apparently lack runghc.

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Sun, 01 Apr 2012 22:25:51 +0300

bnfc (2.4.2.0-1) unstable; urgency=low

  * New upstream release.
  * Converted to source format 3.0 (quilt).
  * Fixed a build failure with recent GHC and Alex.  New patches:
      - remove-haskell98.patch
      - use-alex-3.patch
    Closes: #665063 (FTBFS: Could not find module `Char')
    Reported by Lucas Nussbaum <lucas@lucas-nussbaum.net>.
  * Now generates code that compiles with recent GHC and Alex.  New patches:
      - generate-alex3.patch
      - dont-generate-unqualified.patch
  * Removed Homepage, as it seems to have disappeared.
  * Rewrote the packaging to use dh instead of my aging personal helper script.
  * Rewrote debian/copyright following copyright-format/1.0.
  * Build-Depends:
    - Added ghc as an alternative to ghc6.
    - Added libghc-mtl-dev|libghc6-mtl-dev as it was split off from base.
    - Restricted alex to at least version 3.
    - Added debhelper.
  * Standards-Version 3.9.3.

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Sun, 01 Apr 2012 21:21:59 +0300

bnfc (2.2-3.1) unstable; urgency=low

  * Non-maintainer upload.
  * Convert copyright to UTF-8.
  * Update FSF address.
  * Move Homepage from package description to source header.
  * Make clean not ignore errors.
  * Replace tabs with spaces in source files. (Closes: #460386)

 -- Barry deFreese <bddebian@comcast.net>  Fri, 11 Apr 2008 10:15:28 -0400

bnfc (2.2-3) unstable; urgency=medium

  * The "GHC 6.6 broke my toy" release.
  * Backport GHC 6.6 compilation fix from upstream CVS:
     - formats/cpp/RegToFlex.hs, formats/haskell2/CFtoAlex.hs,
       formats/haskell2/CFtoAlex2.hs, GetCF.hs:
       remove paragraph character (§) from lexer specs
     - CF.hs: remove latin-1 whitespace character
    Closes: #393590 (FTBFS with ghc6 6.6)
    Reported by Arjan Oosting <arjanoosting@home.nl>.
  * Standards-Version bumped to 3.7.2, no changes required.

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Tue, 17 Oct 2006 19:00:41 +0300

bnfc (2.2-2) unstable; urgency=low

  * The C++ transition made this package uninstallable.  Rebuild with new
    ghc to fix this (Build-Depends adjusted accordingly).
  * Standards-Version bumped to 3.6.2, no changes required.

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Mon, 19 Sep 2005 13:16:39 +0300

bnfc (2.2-1) unstable; urgency=low

  * New upstream release
    - incorporates our change
        Makefile (GHC_OPTS): Remove -Wall to avoid clutter at build time
  * debian/copyright: Update.
  * Makefile: clean should remove formats/{profile,xml}/*.{hi,o}

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Sun, 10 Apr 2005 13:53:34 +0300

bnfc (2.1.2-2) unstable; urgency=low

  * Fix the
    formats/haskell/CFtoAlex2.hs: Do not import Alex in generated code
    change from our diff (apparently our and upstream's patches
    conflicted in a way I did not see before).

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Sun,  2 May 2004 22:56:44 +0300

bnfc (2.1.2-1) unstable; urgency=low

  * New upstream release
    - incorporates our change
      formats/haskell/CFtoAlex2.hs: Do not import Alex in generated code
  * debian/control [Build-Depends]: Add a version clause for ghc6, to
    make sure that dynamically linked executables are produced on all
    arches.  Thanks to Ian Lynagh.
    Closes: #241591 ((hppa/unstable): FTBFS: ldd errors)
  * debian/rules: lbnf_spec.tex has been replaced by LBNF-report.tex

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Wed, 14 Apr 2004 17:46:00 +0300

bnfc (2.1-1) unstable; urgency=low

  * Initial packaging (closes: #151046).
  * Makefile (GHC_OPTS): Remove -Wall to avoid clutter at build time
  * formats/haskell/CFtoAlex2.hs: Do not import Alex in generated code
 
 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Sun, 21 Mar 2004 12:41:54 +0200

=== debian/control ===
Source: bnfc
Priority: optional
Section: devel
Maintainer: Antti-Juhani Kaijanaho <ajk@debian.org>
Build-Depends: debhelper (>= 9), ghc (>= 7.0.1) | ghc6 (>= 6.10.1+dfsg1), alex (>= 3.0.1), libghc-mtl-dev | libghc6-mtl-dev
Standards-Version: 3.9.3

Package: bnfc
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Compiler front-end generator based on Labelled BNF
 The BNF Converter is a compiler construction tool that generates a
 compiler front-end and a readable syntax description document from a
 Labelled BNF grammar. It was originally written to generate Haskell,
 but it can now also be used for generating Java, C++, and C.
 .
 To process Haskell output, you need the Glorious Glasgow Haskell
 Compiler (virtual package ghc), the Happy parser generator (package
 happy) and the Alex scanner generator (package alex).
 .
 To process Java output, you need a Java compiler and virtual machine,
 the CUP parser generator (package cup) and the JLex scanner generator
 (package jlex).
 .
 To process C or C++ output, you need a C or C++ compiler,
 respectively, the Bison parser generator (package bison) and the flex
 scanner generator (package flex).
 .
 To process the generated documents, you need LaTeX (packages
 tetex-base, tetex-bin, etc.).

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@

override_dh_auto_configure:
	ghc --make -o Setup Setup.lhs
	./Setup configure --ghc \
		--prefix=/usr --docdir=/usr/share/doc/bnfc

override_dh_auto_build:
	./Setup build

override_dh_auto_install:
	./Setup copy --destdir=debian/bnfc
	rm debian/bnfc/usr/share/doc/bnfc/COPYING

override_dh_auto_clean:
	set -e ; if [ -x ./Setup ]; then ./Setup clean ; fi
	rm -f Setup Setup.hi Setup.o

## bnfc 2.6.0.3

=== debian/changelog ===
bnfc (2.6.0.3-2) unstable; urgency=low

  * Change Homepage field (Closes: #677988)
  * Enable compat level 9
  * Bump standards version to 3.9.4

 -- Joachim Breitner <nomeata@debian.org>  Fri, 24 May 2013 12:49:41 +0200

bnfc (2.6.0.3-1) experimental; urgency=low

  * New upstream release
  * Adopt package by the Debian Haskell Group (Closes: 665783)

 -- Joachim Breitner <nomeata@debian.org>  Sat, 11 May 2013 14:40:44 +0200

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,24 @@
 Source: bnfc
-Priority: optional
-Section: devel
-Maintainer: Antti-Juhani Kaijanaho <ajk@debian.org>
-Build-Depends: debhelper (>= 9), ghc (>= 7.0.1) | ghc6 (>= 6.10.1+dfsg1), alex (>= 3.0.1), libghc-mtl-dev | libghc6-mtl-dev
-Standards-Version: 3.9.3
+Section: haskell
+Priority: extra
+Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
+Uploaders: Joachim Breitner <nomeata@debian.org>
+Build-Depends: debhelper (>= 9)
+  , cdbs
+  , haskell-devscripts (>= 0.8.13)
+  , ghc
+  , ghc-prof
+  , libghc-mtl-dev
+  , libghc-process-dev
+  , alex
+  , happy
+Standards-Version: 3.9.4
+Homepage: http://bnfc.digitalgrammars.com/
+Vcs-Darcs: http://darcs.debian.org/pkg-haskell/bnfc
+Vcs-Browser: http://darcs.debian.org/cgi-bin/darcsweb.cgi?r=pkg-haskell/bnfc
 
 Package: bnfc
+Section: devel
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Compiler front-end generator based on Labelled BNF

=== debian/watch ===
version=3
opts="downloadurlmangle=s|archive/([\w\d_-]+)/([\d\.]+)/|archive/$1/$2/$1-$2.tar.gz|,\
filenamemangle=s|(.*)/$|BNFC-$1.tar.gz|" \
    http://hackage.haskell.org/packages/archive/BNFC \
    ([\d\.]*\d)/

## bnfc 2.8

=== debian/changelog ===
bnfc (2.8-4) unstable; urgency=medium

  * Switch Vcs-Git/Vcs-Browser headers to new location.

 -- Clint Adams <clint@debian.org>  Thu, 03 Dec 2015 14:54:01 -0500

bnfc (2.8-3) experimental; urgency=medium

  [ Joachim Breitner ]
  * General lintian cleanup

 -- Sven Bartscher <sven.bartscher@weltraumschlangen.de>  Tue, 29 Sep 2015 17:50:33 +0200

bnfc (2.8-2) experimental; urgency=medium

  * Add lintian override for spurious rpaths

 -- Joachim Breitner <nomeata@debian.org>  Thu, 20 Aug 2015 15:03:50 +0200

bnfc (2.8-1) experimental; urgency=medium

  * New upstream release
  * Bump standards-version to 3.9.6
  * Depend on haskell-devscripts >= 0.10 to ensure that this package
    builds against GHC in experimental

 -- Joachim Breitner <nomeata@debian.org>  Thu, 20 Aug 2015 10:26:51 +0200

bnfc (2.6.0.3-4) unstable; urgency=medium

  * Upload to unstable

 -- Joachim Breitner <nomeata@debian.org>  Mon, 27 Apr 2015 11:47:22 +0200

bnfc (2.6.0.3-3) experimental; urgency=low

  * Adjust watch file to new hackage layout
  * Depend on haskell-devscripts 0.9, found in experimental

 -- Joachim Breitner <nomeata@debian.org>  Sat, 20 Dec 2014 17:09:19 +0100

=== debian/control ===
--- 
+++ 
@@ -1,26 +1,26 @@
 Source: bnfc
-Section: haskell
-Priority: extra
 Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
 Uploaders: Joachim Breitner <nomeata@debian.org>
-Build-Depends: debhelper (>= 9)
-  , cdbs
-  , haskell-devscripts (>= 0.8.13)
-  , ghc
-  , ghc-prof
-  , libghc-mtl-dev
-  , libghc-process-dev
-  , alex
-  , happy
-Standards-Version: 3.9.4
+Priority: extra
+Section: haskell
+Build-Depends: debhelper (>= 9),
+ haskell-devscripts (>= 0.10),
+ cdbs,
+ ghc,
+ ghc-prof,
+ libghc-mtl-dev,
+ alex,
+ happy,
+Standards-Version: 3.9.6
 Homepage: http://bnfc.digitalgrammars.com/
-Vcs-Darcs: http://darcs.debian.org/pkg-haskell/bnfc
-Vcs-Browser: http://darcs.debian.org/cgi-bin/darcsweb.cgi?r=pkg-haskell/bnfc
+Vcs-Browser: https://anonscm.debian.org/cgit/pkg-haskell/DHG_packages.git/
+Vcs-Git: git://git.debian.org/git/pkg-haskell/DHG_packages.git
 
 Package: bnfc
+Architecture: any
 Section: devel
-Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${shlibs:Depends},
+ ${misc:Depends},
 Description: Compiler front-end generator based on Labelled BNF
  The BNF Converter is a compiler construction tool that generates a
  compiler front-end and a readable syntax description document from a

## bnfc 2.8.1

=== debian/changelog ===
bnfc (2.8.1-3) unstable; urgency=medium

  * Upload to unstable as part of GHC 8 transition.

 -- Clint Adams <clint@debian.org>  Thu, 27 Oct 2016 18:32:13 -0400

bnfc (2.8.1-2) experimental; urgency=medium

  * Temporarily build-depend on ghc 8.

 -- Clint Adams <clint@debian.org>  Sun, 16 Oct 2016 14:26:12 -0400

bnfc (2.8.1-1) unstable; urgency=medium

  [ Dmitry Bogatov ]
  * Use secure (https) uri in Vcs-Git field in 'debian/control'

  [ Clint Adams ]
  * New upstream release

 -- Clint Adams <clint@debian.org>  Mon, 05 Sep 2016 00:00:43 -0400

bnfc (2.8-5) unstable; urgency=medium

  * Fill in more authors in debian/copyright
  * Fix source location in debina/copyright
  * Bump standards version to 3.9.8 (no changes needed)

 -- Dmitry Bogatov <KAction@gnu.org>  Sat, 07 May 2016 08:11:58 +0300

=== debian/control ===
--- 
+++ 
@@ -1,26 +1,30 @@
 Source: bnfc
 Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
-Uploaders: Joachim Breitner <nomeata@debian.org>
+Uploaders:
+ Joachim Breitner <nomeata@debian.org>,
+ Dmitry Bogatov <KAction@gnu.org>,
 Priority: extra
 Section: haskell
-Build-Depends: debhelper (>= 9),
- haskell-devscripts (>= 0.10),
+Build-Depends:
+ alex,
  cdbs,
- ghc,
+ debhelper (>= 9),
+ ghc (>= 8),
  ghc-prof,
+ happy,
+ haskell-devscripts (>= 0.13),
  libghc-mtl-dev,
- alex,
- happy,
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Homepage: http://bnfc.digitalgrammars.com/
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-haskell/DHG_packages.git/
-Vcs-Git: git://git.debian.org/git/pkg-haskell/DHG_packages.git
+Vcs-Browser: https://anonscm.debian.org/cgit/pkg-haskell/DHG_packages.git/tree/p/bnfc
+Vcs-Git: https://anonscm.debian.org/git/pkg-haskell/DHG_packages.git
 
 Package: bnfc
 Architecture: any
 Section: devel
-Depends: ${shlibs:Depends},
+Depends:
  ${misc:Depends},
+ ${shlibs:Depends},
 Description: Compiler front-end generator based on Labelled BNF
  The BNF Converter is a compiler construction tool that generates a
  compiler front-end and a readable syntax description document from a

=== debian/watch ===
version=3
http://hackage.haskell.org/package/BNFC/distro-monitor .*-([0-9\.]+).(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## bnfc 2.8.3

=== Makefile ===
# GHC major.minor
GHC_VERSION := $(shell ghc --numeric-version | cut -d. -f1-2)
BNFC_VERSION=$(shell sed -ne "s/^[Vv]ersion: *\([0-9.]*\).*/\1/p" BNFC.cabal)

# Cabal options (to be overwritten from the command line)
CABAL_OPTS           =
CABAL_BUILD_OPTS     = --builddir=dist-ghc-$(GHC_VERSION)
CABAL_CONFIGURE_OPTS = --enable-tests
CABAL_INSTALL_OPTS   = $(CABAL_CONFIGURE_OPTS) $(CABAL_BUILD_OPTS)
CABAL_TEST_OPTS      = $(CABAL_BUILD_OPTS)

CABAL                = cabal $(CABAL_OPTS)
CABAL_CONFIGURE      = $(CABAL) configure $(CABAL_CONFIGURE_OPTS)
CABAL_BUILD          = $(CABAL) build     $(CABAL_BUILD_OPTS)
CABAL_INSTALL        = $(CABAL) install   $(CABAL_INSTALL_OPTS)
CABAL_TEST           = $(CABAL) test      $(CABAL_TEST_OPTS)

# Name for binary distribution (e.g. bnfc-2.4.5-linux32)
BDIST_TAG=bnfc-${BNFC_VERSION}-$(shell uname -s)-$(shell uname -m)

.PHONY: default build install doc test bdist show-version debug TAGS

default: install test

build:
	$(CABAL_CONFIGURE) && $(CABAL_BUILD)

install:
	$(CABAL_INSTALL)

test:
	$(CABAL_CONFIGURE)
	$(CABAL_TEST)

doc:
	$(CABAL) haddock --executables --internal

TAGS :
	hasktags --etags .

# Binary package (tgz, for linux)
bdist: dist/${BDIST_TAG}.tar.gz

dist/%.tar.gz:
	cabal clean
	cabal install ${CABAL_OPTS} --only-dependencies
	cabal configure ${CABAL_OPTS} --prefix=/
	cabal build ${CABAL_OPTS}
	cabal copy --destdir=dist/install
	mkdir dist/$*
	cp dist/install/bin/bnfc dist/$*
	cp LICENSE dist/$*
	tar -cvz -C dist $* > $@

# Print the bnfc version from the cabal file
show-version:
	@echo ${BNFC_VERSION}

debug:
	@echo GHC_VERSION  = $(GHC_VERSION)
	@echo BNFC_VERSION = $(BNFC_VERSION)
# EOF

=== debian/changelog ===
bnfc (2.8.3-1) unstable; urgency=medium

  [ Ilias Tsitsimpis ]
  * Remove Dmitry Bogatov from Uploaders per his request. Thank you
    Dmitry for your previous maintainership.

  [ Sean Whitton ]
  * New upstream release

  [ Ilias Tsitsimpis ]
  * Bump std-version to 4.5.0

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Thu, 18 Jun 2020 13:41:36 +0300

bnfc (2.8.1-6) unstable; urgency=medium

  * Patch to build with ghc-8.4

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Thu, 04 Oct 2018 14:53:27 +0300

bnfc (2.8.1-5) unstable; urgency=medium

  [ Clint Adams ]
  * Set Rules-Requires-Root to no.

  [ Ilias Tsitsimpis ]
  * Bump debhelper compat level to 10
  * Remove build dependency on libghc-mtl-dev (provided by ghc-8.4.3)

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Mon, 01 Oct 2018 13:33:20 +0300

bnfc (2.8.1-4) unstable; urgency=medium

  [ Ilias Tsitsimpis ]
  * Change Priority to optional. Since Debian Policy version 4.0.1,
    priority extra has been deprecated.
  * Use the HTTPS form of the copyright-format URL
  * Modify d/watch and Source field in d/copyright to use HTTPS
  * Declare compliance with Debian policy 4.1.1
  * Use salsa.debian.org URLs in Vcs-{Browser,Git} fields

  [ Clint Adams ]
  * Bump to Standards-Version 4.1.4.

 -- Clint Adams <clint@debian.org>  Mon, 09 Apr 2018 20:04:39 -0400

=== debian/control ===
--- 
+++ 
@@ -2,22 +2,25 @@
 Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
 Uploaders:
  Joachim Breitner <nomeata@debian.org>,
- Dmitry Bogatov <KAction@gnu.org>,
-Priority: extra
+ Ilias Tsitsimpis <iliastsi@debian.org>,
+Priority: optional
 Section: haskell
+Rules-Requires-Root: no
 Build-Depends:
  alex,
  cdbs,
- debhelper (>= 9),
- ghc (>= 8),
+ debhelper (>= 10),
+ ghc (>= 8.4.3),
  ghc-prof,
  happy,
  haskell-devscripts (>= 0.13),
- libghc-mtl-dev,
-Standards-Version: 3.9.8
+ libghc-semigroups-dev,
+ libghc-semigroups-prof,
+Build-Depends-Indep: ghc-doc,
+Standards-Version: 4.5.0
 Homepage: http://bnfc.digitalgrammars.com/
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-haskell/DHG_packages.git/tree/p/bnfc
-Vcs-Git: https://anonscm.debian.org/git/pkg-haskell/DHG_packages.git
+Vcs-Browser: https://salsa.debian.org/haskell-team/DHG_packages/tree/master/p/bnfc
+Vcs-Git: https://salsa.debian.org/haskell-team/DHG_packages.git [p/bnfc]
 
 Package: bnfc
 Architecture: any

=== debian/watch ===
version=3
https://hackage.haskell.org/package/BNFC/distro-monitor .*-([0-9\.]+).(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## bnfc 2.9.4

=== Makefile ===
# GHC major.minor
GHC_VERSION := $(shell ghc --numeric-version | cut -d. -f1-2)
BNFC_VERSION=$(shell sed -ne "s/^[Vv]ersion: *\([0-9.]*\).*/\1/p" BNFC.cabal)

# Cabal options (to be overwritten from the command line)
CABAL_OPTS           =
CABAL_BUILDDIR_SUFFIX=
CABAL_BUILD_OPTS     = --builddir=dist-ghc-$(GHC_VERSION)$(CABAL_BUILDDIR_SUFFIX)
CABAL_CONFIGURE_OPTS = --enable-tests
CABAL_INSTALL_OPTS   = $(CABAL_CONFIGURE_OPTS) $(CABAL_BUILD_OPTS)
CABAL_TEST_OPTS      = $(CABAL_BUILD_OPTS)

CABAL                = cabal $(CABAL_OPTS)
CABAL_CONFIGURE      = $(CABAL) v1-configure $(CABAL_CONFIGURE_OPTS)
CABAL_BUILD          = $(CABAL) v1-build     $(CABAL_BUILD_OPTS)
CABAL_INSTALL        = $(CABAL) v1-install   $(CABAL_INSTALL_OPTS)
CABAL_TEST           = $(CABAL) v1-test      $(CABAL_TEST_OPTS)

# Name for binary distribution (e.g. bnfc-2.4.5-linux32)
BDIST_TAG=bnfc-${BNFC_VERSION}-$(shell uname -s)-$(shell uname -m)

.PHONY: default build install doc test bdist show-version debug weed TAGS

default: install test

build:
	$(CABAL_CONFIGURE) && $(CABAL_BUILD)

install:
	$(CABAL_INSTALL)

test:
	$(CABAL_TEST)

haddock doc:
	$(CABAL) v1-haddock --hyperlink-source
# --executables --internal

# See https://hackage.haskell.org/package/weeder
# weeder can find dead code starting from the .hie files
weed:
	$(CABAL) build --project-file=cabal.project.local
	weeder

TAGS :
	hasktags --etags .

# Binary package (tgz, for linux)
bdist: dist/${BDIST_TAG}.tar.gz

dist/%.tar.gz:
	cabal v1-clean
	cabal v1-install ${CABAL_OPTS} --only-dependencies
	cabal v1-configure ${CABAL_OPTS} --prefix=/
	cabal v1-build ${CABAL_OPTS}
	cabal v1-copy --destdir=dist/install
	mkdir dist/$*
	cp dist/install/bin/bnfc dist/$*
	cp LICENSE dist/$*
	tar -cvz -C dist $* > $@

# Print the bnfc version from the cabal file
show-version:
	@echo ${BNFC_VERSION}

debug:
	@echo GHC_VERSION  = $(GHC_VERSION)
	@echo BNFC_VERSION = $(BNFC_VERSION)
# EOF

=== debian/changelog ===
bnfc (2.9.4-1) unstable; urgency=medium

  * Declare compliance with Debian policy 4.6.1
  * Remove retired developer, Joachim Breitner, from Uploaders.
  * New upstream release

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Thu, 21 Jul 2022 11:01:47 +0300

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,6 @@
 Source: bnfc
 Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
 Uploaders:
- Joachim Breitner <nomeata@debian.org>,
  Ilias Tsitsimpis <iliastsi@debian.org>,
 Priority: optional
 Section: haskell
@@ -14,10 +13,12 @@
  ghc-prof,
  happy,
  haskell-devscripts (>= 0.13),
- libghc-semigroups-dev,
- libghc-semigroups-prof,
-Build-Depends-Indep: ghc-doc,
-Standards-Version: 4.5.0
+ libghc-string-qq-dev,
+ libghc-string-qq-prof,
+ libghc-cabal-doctest-dev (>= 1),
+ libghc-cabal-doctest-dev (<< 1.1),
+ libghc-cabal-doctest-prof,
+Standards-Version: 4.6.1
 Homepage: http://bnfc.digitalgrammars.com/
 Vcs-Browser: https://salsa.debian.org/haskell-team/DHG_packages/tree/master/p/bnfc
 Vcs-Git: https://salsa.debian.org/haskell-team/DHG_packages.git [p/bnfc]

## bnfc 2.9.5

=== Makefile ===
--- 
+++ 
@@ -5,36 +5,50 @@
 # Cabal options (to be overwritten from the command line)
 CABAL_OPTS           =
 CABAL_BUILDDIR_SUFFIX=
-CABAL_BUILD_OPTS     = --builddir=dist-ghc-$(GHC_VERSION)$(CABAL_BUILDDIR_SUFFIX)
+CABAL_BUILD_OPTS     = --enable-tests
+# --builddir=dist-ghc-$(GHC_VERSION)$(CABAL_BUILDDIR_SUFFIX)
 CABAL_CONFIGURE_OPTS = --enable-tests
-CABAL_INSTALL_OPTS   = $(CABAL_CONFIGURE_OPTS) $(CABAL_BUILD_OPTS)
+CABAL_INSTALL_OPTS   = $(CABAL_CONFIGURE_OPTS) $(CABAL_BUILD_OPTS) --overwrite-policy=always
 CABAL_TEST_OPTS      = $(CABAL_BUILD_OPTS)
 
 CABAL                = cabal $(CABAL_OPTS)
-CABAL_CONFIGURE      = $(CABAL) v1-configure $(CABAL_CONFIGURE_OPTS)
-CABAL_BUILD          = $(CABAL) v1-build     $(CABAL_BUILD_OPTS)
-CABAL_INSTALL        = $(CABAL) v1-install   $(CABAL_INSTALL_OPTS)
-CABAL_TEST           = $(CABAL) v1-test      $(CABAL_TEST_OPTS)
+CABAL_CONFIGURE      = $(CABAL) configure $(CABAL_CONFIGURE_OPTS)
+CABAL_BUILD          = $(CABAL) build     $(CABAL_BUILD_OPTS)
+CABAL_INSTALL        = $(CABAL) install   $(CABAL_INSTALL_OPTS)
+CABAL_TEST           = $(CABAL) test      $(CABAL_TEST_OPTS)
 
 # Name for binary distribution (e.g. bnfc-2.4.5-linux32)
 BDIST_TAG=bnfc-${BNFC_VERSION}-$(shell uname -s)-$(shell uname -m)
 
 .PHONY: default build install doc test bdist show-version debug weed TAGS
 
-default: install test
+default: build cabal-test doctest-quick
 
 build:
-	$(CABAL_CONFIGURE) && $(CABAL_BUILD)
+	$(CABAL_BUILD)
 
 install:
 	$(CABAL_INSTALL)
 
-test:
+test: build cabal-test doctest
+
+cabal-test:
 	$(CABAL_TEST)
 
-haddock doc:
-	$(CABAL) v1-haddock --hyperlink-source
-# --executables --internal
+doctest: build doctest-install doctest-quick
+
+doctest-install:
+	cabal install doctest --program-suffix=-${GHC_VERSION}
+
+doctest-quick:
+	cabal repl -w doctest-${GHC_VERSION} --repl-options=-Wno-type-defaults
+# --ghc-options=-Wno-type-defaults needed due to OverloadedStrings.
+# But it does not get used here, needs to go into cabal file.
+# see: https://github.com/sol/doctest/issues/390
+# --repl-options seems to work, though
+
+haddock:
+	$(CABAL) haddock
 
 # See https://hackage.haskell.org/package/weeder
 # weeder can find dead code starting from the .hie files

=== src/Makefile ===
# Author: Andreas Abel, 2018-01-01, 2020-12-22

.PHONY : default all

default: lbnf
all: lbnf license

# bnfc's own parser
###################

# BNFC-generated files
gen = BNFC/Abs.hs BNFC/Doc.txt ErrM.hs BNFC/Lex.x BNFC/Par.y BNFC/Print.hs BNFC/Skel.hs BNFC/Test.hs

.PHONY: lbnf

lbnf : BNFC/Abs.hs BNFC/Lex.hs BNFC/Par.hs BNFC/Print.hs

%/Abs.hs %/Doc.txt %/Lex.x %/Par.y %/Print.hs %/Skel.hs %/Test.hs : %.cf
	bnfc --haskell -d $<

%.hs : %.x
	alex -g $<

%.hs : %.y
	happy -gcai $<

# Generate License.hs
#####################

.PHONY: license

license: BNFC/License.hs

BNFC/License.hs : ../LICENSE Makefile
	echo "\
-- This file was autogenerated from LICENSE, do not edit!!\n\n\
{-# LANGUAGE QuasiQuotes #-}\n\n\
module BNFC.License where\n\n\
import Data.String.QQ\n\n\
license :: String\n\
license = [s|" > $@
	cat $< >> $@
	echo "\n|]" >> $@

# Emacs Tags
############

.PHONY : tags

tags :
	hasktags -e .

# Fake cabal file for old version of haskell-mode (emacs)
#########################################################

.PHONY: fake-cabal rm-fake-cabal

fake-cabal :
	touch inferior-haskell-find-project-root.cabal

# Remove this this file confuses tools like cabal and stack.
rm-fake-cabal :
	rm inferior-haskell-find-project-root.cabal

#EOF

=== debian/changelog ===
bnfc (2.9.5-1) unstable; urgency=medium

  * Declare compliance with Debian policy 4.6.2
  * New upstream release

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Thu, 31 Aug 2023 16:18:55 +0300

=== debian/control ===
--- 
+++ 
@@ -9,17 +9,12 @@
  alex,
  cdbs,
  debhelper (>= 10),
- ghc (>= 8.4.3),
- ghc-prof,
+ ghc (>= 9.4),
  happy,
  haskell-devscripts (>= 0.13),
  libghc-string-qq-dev,
- libghc-string-qq-prof,
- libghc-cabal-doctest-dev (>= 1),
- libghc-cabal-doctest-dev (<< 1.1),
- libghc-cabal-doctest-prof,
-Standards-Version: 4.6.1
-Homepage: http://bnfc.digitalgrammars.com/
+Standards-Version: 4.6.2
+Homepage: https://bnfc.digitalgrammars.com/
 Vcs-Browser: https://salsa.debian.org/haskell-team/DHG_packages/tree/master/p/bnfc
 Vcs-Git: https://salsa.debian.org/haskell-team/DHG_packages.git [p/bnfc]

## bnfc 2.9.6.1

=== Makefile ===
--- 
+++ 
@@ -8,7 +8,7 @@
 CABAL_BUILD_OPTS     = --enable-tests
 # --builddir=dist-ghc-$(GHC_VERSION)$(CABAL_BUILDDIR_SUFFIX)
 CABAL_CONFIGURE_OPTS = --enable-tests
-CABAL_INSTALL_OPTS   = $(CABAL_CONFIGURE_OPTS) $(CABAL_BUILD_OPTS) --overwrite-policy=always
+CABAL_INSTALL_OPTS   = --overwrite-policy=always
 CABAL_TEST_OPTS      = $(CABAL_BUILD_OPTS)
 
 CABAL                = cabal $(CABAL_OPTS)
@@ -38,7 +38,7 @@
 doctest: build doctest-install doctest-quick
 
 doctest-install:
-	cabal install doctest --program-suffix=-${GHC_VERSION}
+	cabal install doctest --ignore-project --program-suffix=-${GHC_VERSION}
 
 doctest-quick:
 	cabal repl -w doctest-${GHC_VERSION} --repl-options=-Wno-type-defaults
@@ -62,6 +62,15 @@
 # Binary package (tgz, for linux)
 bdist: dist/${BDIST_TAG}.tar.gz
 
+# Source package
+# Andreas, 2023-11-03, PR #466: need to remove BNFC/{Lex,Par}.hs,
+# otherwise they will be shipped in the sdist package
+# and cause compilation to fail.
+sdist:
+	make -C src clean
+	cabal sdist
+
+# OLD goal
 dist/%.tar.gz:
 	cabal v1-clean
 	cabal v1-install ${CABAL_OPTS} --only-dependencies

=== src/Makefile ===
--- 
+++ 
@@ -62,4 +62,8 @@
 rm-fake-cabal :
 	rm inferior-haskell-find-project-root.cabal
 
+.PHONY: clean
+clean :
+	rm BNFC/Lex.hs BNFC/Par.hs BNFC/*.bak
+
 #EOF

=== debian/changelog ===
bnfc (2.9.6.1-1) unstable; urgency=medium

  [ Ilias Tsitsimpis ]
  * Declare compliance with Debian policy 4.7.0

  [ Scott Talbert ]
  * Build using dh-haskell
  * New upstream release

 -- Scott Talbert <swt@techie.net>  Mon, 05 Jan 2026 18:23:11 -0500

=== debian/control ===
--- 
+++ 
@@ -7,13 +7,13 @@
 Rules-Requires-Root: no
 Build-Depends:
  alex,
- cdbs,
- debhelper (>= 10),
- ghc (>= 9.4),
+ dh-sequence-haskell,
+ debhelper-compat (= 13),
+ ghc (>= 9.10),
  happy,
  haskell-devscripts (>= 0.13),
  libghc-string-qq-dev,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://bnfc.digitalgrammars.com/
 Vcs-Browser: https://salsa.debian.org/haskell-team/DHG_packages/tree/master/p/bnfc
 Vcs-Git: https://salsa.debian.org/haskell-team/DHG_packages.git [p/bnfc]
